/**
 *  Copyright (C) 2012  plegal  (plegal@appert44.org)
 *  @file         CAdrRadio.h
 *  @brief        Classe pour les adresses radio des composants WAVENIS
 *  @version      0.1
 *  @date         17 déc. 2012 21:27:53
 *
 *  @note         Voir la description detaillee explicite dans le fichier
 *                CAdrRadio.cpp
 *                C++ Google Style :
 *                http://google-styleguide.googlecode.com/svn/trunk/cppguide.xml
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef _CADRRADIO_H
#define _CADRRADIO_H

// Includes system C
//#include <stdint.h>  // definition des types int8_t, int16_t ...

// Includes system C++
#include <string>
using namespace std;
// Includes qt

// Includes application
#include "Property.h"     	// pour créer des properties pour les attributs
#include "commun.h"		// pour Byte

// Constantes
// ex :
// const int kDaysInAWeek = 7;

// Enumerations
// ex :
// enum Couleur
// {
//     kBlue = 0,
//     kWhite,
//     kRed,
// };

// Structures
// ex:
// struct UrlTableProperties
// {
//  string name;
//  int numEntries;
// }

// Declarations de classe avancees
// ex:
// class MaClasse;

/// Espace de noms pour les classes de la librairie WAVENIS
namespace WAVENIS {

/** @brief Classe pour les adresses radio des composants WAVENIS
 *  Description detaillee de la classe.
 */
class CAdrRadio
{



public :
    /**
     * Constructeur
     */
    CAdrRadio(void);
    CAdrRadio(Byte AdrRadio[SIZEADRRADIO]);
    CAdrRadio(string AdrRadio);
    /**
     * Destructeur
     */
    virtual ~CAdrRadio();

    // Methodes publiques de la classe
    // ex : ReturnType NomMethode(Type);
    string ToString();
    Byte *ToBytes();
    property<CAdrRadio,int,READ_ONLY>Taille;
    // Pour les associations :
    // Methodes publiques setter/getter (mutateurs/accesseurs) des attributs prives
    // ex :
    // void setNomAttribut(Type nomAttribut) { nomAttribut_ = nomAttribut; }
    // Type getNomAttribut(void) const { return nomAttribut_; }

protected :
    // Attributs proteges

    // Methode protegees

private :
    // Attributs prives
    // ex :
    // Type nomAttribut_;
    int getTaille()const;
    Byte bAdrRadio[SIZEADRRADIO];
    string strAdrRadio;
    int m_Taille;   // taille de l'adresse Radio
    // Methodes privees
};

// Methodes publiques inline
// ex :
// inline void CAdrRadio::maMethodeInline(Type valeur)
// {
//   
// }
// inline Type CAdrRadio::monAutreMethode_inline_(void)
// {
//   return 0;
// }

} // namespace WAVENIS

#endif  // _CADRRADIO_H

