/*******************************************************************************
 * Copyright (c) 2012 Coronis
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Contributors:
 *     Coronis - initial API and implementation
 *******************************************************************************/
#ifdef _JAVA_WRAPPER
#include "protocol_waveport_enum_converssion.h"
#include <loader_logger.h>

_bool get_radio_channel_enum_field_from_object( JNIEnv * env, jobject object,
		jclass classID, char *eunmItemName, RadioChannel *enumItemValue, int *iRet,
		const int iRetCode) {
	_bool bRet = _false;

	LOG_DEBUG(g_Logger, "get_radio_channel_enum_field_from_object: Entered function", 0);

	jfieldID fieldID = (*env)->GetFieldID( env, classID, eunmItemName, "Lcom/coronis/sdk/protocol/api/ConstantParams$RadioChannel;");
	if ( fieldID != NULL ) {

		LOG_DEBUG(g_Logger, "get_radio_channel_enum_field_from_object: Got field ID transmissionRadioChannel from container object", 0);
		jobject fieldValue = (*env)->GetObjectField( env, object, fieldID );

		if ( fieldValue != NULL ) {
			LOG_DEBUG(g_Logger, "get_radio_channel_enum_field_from_object: Got transmissionRadioChannel field value", 0);
			jclass classRadioChannelEnumID = (*env)->GetObjectClass( env, fieldValue);
			if ( classRadioChannelEnumID != NULL ) {
				jmethodID methodID = (*env)->GetMethodID( env, classRadioChannelEnumID, "name", "()Ljava/lang/String;");
				LOG_DEBUG(g_Logger, "get_radio_channel_enum_field_from_object: Got transmissionRadioChannel classID", 0);
				if ( methodID != NULL ) {
					LOG_DEBUG(g_Logger, "get_radio_channel_enum_field_from_object: Got transmissionRadioChannel enum NAME field", 0);
					jstring value = (jstring)(*env)->CallObjectMethod( env, fieldValue, methodID );
					const char* valueNative = (*env)->GetStringUTFChars(env, value, 0);

					bRet = _true;
					if (strcmp(valueNative, "Channel_0") == 0)
				        *enumItemValue =  RADIO_CHANNEL_0;
					else if (strcmp(valueNative, "Channel_1") == 0)
				        *enumItemValue =  RADIO_CHANNEL_1;
					else if (strcmp(valueNative, "Channel_2") == 0)
				        *enumItemValue =  RADIO_CHANNEL_2;
					else if (strcmp(valueNative, "Channel_3") == 0)
				        *enumItemValue =  RADIO_CHANNEL_3;
					else if (strcmp(valueNative, "Channel_4") == 0)
				        *enumItemValue =  RADIO_CHANNEL_4;
					else if (strcmp(valueNative, "Channel_5") == 0)
				        *enumItemValue =  RADIO_CHANNEL_5;
					else if (strcmp(valueNative, "Channel_6") == 0)
				        *enumItemValue =  RADIO_CHANNEL_6;
					else if (strcmp(valueNative, "Channel_7") == 0)
				        *enumItemValue =  RADIO_CHANNEL_7;
					else if (strcmp(valueNative, "Channel_8") == 0)
				        *enumItemValue =  RADIO_CHANNEL_8;
					else if (strcmp(valueNative, "Channel_9") == 0)
				        *enumItemValue =  RADIO_CHANNEL_9;
					else if (strcmp(valueNative, "Channel_10") == 0)
				        *enumItemValue =  RADIO_CHANNEL_10;
					else if (strcmp(valueNative, "Channel_11") == 0)
				        *enumItemValue =  RADIO_CHANNEL_11;
					else if (strcmp(valueNative, "Channel_12") == 0)
				        *enumItemValue =  RADIO_CHANNEL_12;
					else if (strcmp(valueNative, "Channel_13") == 0)
				        *enumItemValue =  RADIO_CHANNEL_13;
					else if (strcmp(valueNative, "Channel_14") == 0)
				        *enumItemValue =  RADIO_CHANNEL_14;
					else if (strcmp(valueNative, "Channel_15") == 0)
				        *enumItemValue =  RADIO_CHANNEL_15;
					else if (strcmp(valueNative, "Channel_16") == 0)
				        *enumItemValue =  RADIO_CHANNEL_16;
					else if (strcmp(valueNative, "Channel_17") == 0)
				        *enumItemValue =  RADIO_CHANNEL_17;
					else if (strcmp(valueNative, "Channel_18") == 0)
				        *enumItemValue =  RADIO_CHANNEL_18;
					else if (strcmp(valueNative, "Channel_19") == 0)
				        *enumItemValue =  RADIO_CHANNEL_19;
					else if (strcmp(valueNative, "Channel_20") == 0)
				        *enumItemValue =  RADIO_CHANNEL_20;
					else if (strcmp(valueNative, "Channel_21") == 0)
				        *enumItemValue =  RADIO_CHANNEL_21;
					else {
						if (iRet)*iRet = iRetCode;
						bRet = _false;
					}

					LOG_DEBUG( g_Logger, "get_radio_channel_enum_field_from_object: Java EnumValue is : %s, C EnumValue is %d", valueNative, *enumItemValue);
				}
				(*env)->DeleteLocalRef( env, classRadioChannelEnumID);
			}
			(*env)->DeleteLocalRef( env, fieldValue);
		}
	}

	LOG_DEBUG(g_Logger, "get_transmission_radio_channel_enum_field_from_object: Exit function", 0);
	return bRet;
}

_bool get_reception_mode_enum_field_from_object( JNIEnv * env, jobject object,
									jclass classID, ReceptionMode *receptionMode, int *iRet ) {

	_bool bRet = _false;

	LOG_DEBUG(g_Logger, "get_reception_mode_enum_field_from_object: Entered function", 0);

	jfieldID fieldID = (*env)->GetFieldID( env, classID, "receptionMode", "Lcom/coronis/sdk/protocol/api/ConstantParams$ReceptionMode;");
	if ( fieldID != NULL ) {

		LOG_DEBUG(g_Logger, "get_reception_mode_enum_field_from_object: Got field ID receptionMode from container object", 0);
		jobject fieldValue = (*env)->GetObjectField( env, object, fieldID );

		if ( fieldValue != NULL ) {
			LOG_DEBUG(g_Logger, "get_reception_mode_enum_field_from_object: Got receptionMode field value", 0);
			jclass classReceptionModeEnumID = (*env)->GetObjectClass( env, fieldValue);
			if ( classReceptionModeEnumID != NULL ) {
				jmethodID methodID = (*env)->GetMethodID( env, classReceptionModeEnumID, "name", "()Ljava/lang/String;");
				LOG_DEBUG(g_Logger, "get_reception_mode_enum_field_from_object: Got receptionMode classReceptionModeEnumID", 0);
				if ( methodID != NULL ) {
					LOG_DEBUG(g_Logger, "get_reception_mode_enum_field_from_object: Got receptionMode enum NAME field", 0);
					jstring value = (jstring)(*env)->CallObjectMethod( env, fieldValue, methodID );
					const char* valueNative = (*env)->GetStringUTFChars(env, value, 0);

					bRet = _true;
					if (strcmp(valueNative, "Unicast") == 0)
				        *receptionMode =  RECEPTION_MODE_UNICAST;
					else if (strcmp(valueNative, "Multicast") == 0)
						*receptionMode =  RECEPTION_MODE_MULTICAST;
					else if (strcmp(valueNative, "Broadcast") == 0)
						*receptionMode =  RECEPTION_MODE_BROADCAST;
					else {
						if (iRet)*iRet = KO_PARAMETER_RECEPTION_MODE_NOT_VALID;
						bRet = _false;
					}

					LOG_DEBUG( g_Logger, "get_reception_mode_enum_field_from_object: Java EnumValue is : %s, C EnumValue is %d", valueNative, *receptionMode);
				}
				(*env)->DeleteLocalRef( env, classReceptionModeEnumID);
			}
			(*env)->DeleteLocalRef( env, fieldValue);
		}
	}

	LOG_DEBUG(g_Logger, "get_reception_mode_enum_field_from_object: Exit function", 0);
	return bRet;
}

jobject create_radiochannel_enum_object ( JNIEnv *env, RadioChannel enumValue ) {

	jobject jEnumObject 	= NULL;
	jclass  jEnumClass 		= (*env)->FindClass( env, "com/coronis/sdk/protocol/api/ConstantParams$RadioChannel");
	jstring jEnumValueName  = NULL;

	LOG_DEBUG(g_Logger, "create_radiochannel_enum_object: Entered function to set radiochannel to %d", enumValue);

	if (enumValue == RADIO_CHANNEL_0)
		jEnumValueName = (*env)->NewStringUTF( env, "Channel_0" );
	else if (enumValue == RADIO_CHANNEL_1)
		jEnumValueName = (*env)->NewStringUTF( env, "Channel_1" );
	else if (enumValue == RADIO_CHANNEL_2)
		jEnumValueName = (*env)->NewStringUTF( env, "Channel_2" );
	else if (enumValue == RADIO_CHANNEL_3)
		jEnumValueName = (*env)->NewStringUTF( env, "Channel_3" );
	else if (enumValue == RADIO_CHANNEL_4)
		jEnumValueName = (*env)->NewStringUTF( env, "Channel_4" );
	else if (enumValue == RADIO_CHANNEL_5)
		jEnumValueName = (*env)->NewStringUTF( env, "Channel_5" );
	else if (enumValue == RADIO_CHANNEL_6)
		jEnumValueName = (*env)->NewStringUTF( env, "Channel_6" );
	else if (enumValue == RADIO_CHANNEL_7)
		jEnumValueName = (*env)->NewStringUTF( env, "Channel_7" );
	else if (enumValue == RADIO_CHANNEL_8)
		jEnumValueName = (*env)->NewStringUTF( env, "Channel_8" );
	else if (enumValue == RADIO_CHANNEL_9)
		jEnumValueName = (*env)->NewStringUTF( env, "Channel_9" );
	else if (enumValue == RADIO_CHANNEL_10)
		jEnumValueName = (*env)->NewStringUTF( env, "Channel_10" );
	else if (enumValue == RADIO_CHANNEL_11)
		jEnumValueName = (*env)->NewStringUTF( env, "Channel_11" );
	else if (enumValue == RADIO_CHANNEL_12)
		jEnumValueName = (*env)->NewStringUTF( env, "Channel_12" );
	else if (enumValue == RADIO_CHANNEL_13)
		jEnumValueName = (*env)->NewStringUTF( env, "Channel_13" );
	else if (enumValue == RADIO_CHANNEL_14)
		jEnumValueName = (*env)->NewStringUTF( env, "Channel_14" );
	else if (enumValue == RADIO_CHANNEL_15)
		jEnumValueName = (*env)->NewStringUTF( env, "Channel_15" );
	else if (enumValue == RADIO_CHANNEL_16)
		jEnumValueName = (*env)->NewStringUTF( env, "Channel_16" );
	else if (enumValue == RADIO_CHANNEL_17)
		jEnumValueName = (*env)->NewStringUTF( env, "Channel_17" );
	else if (enumValue == RADIO_CHANNEL_18)
		jEnumValueName = (*env)->NewStringUTF( env, "Channel_18" );
	else if (enumValue == RADIO_CHANNEL_19)
		jEnumValueName = (*env)->NewStringUTF( env, "Channel_19" );
	else if (enumValue == RADIO_CHANNEL_20)
		jEnumValueName = (*env)->NewStringUTF( env, "Channel_20" );
	else if (enumValue == RADIO_CHANNEL_21)
		jEnumValueName = (*env)->NewStringUTF( env, "Channel_21" );
	else
		return NULL;

	LOG_DEBUG(g_Logger, "create_radiochannel_enum_object: Creating enum object", 0);
	// create enumeration with desired value
	jEnumObject = (*env)->CallStaticObjectMethod(env, jEnumClass,
					(*env)->GetStaticMethodID(env, jEnumClass, "valueOf",
							"(Ljava/lang/String;)Lcom/coronis/sdk/protocol/api/ConstantParams$RadioChannel;"),
							jEnumValueName);

	if(jEnumObject != NULL) {
		LOG_DEBUG(g_Logger, "create_radiochannel_enum_object: Enum object created", 0);
	}

	if(jEnumObject == NULL) {
		LOG_ERROR(g_Logger, "create_radiochannel_enum_object: Failed to create enum object", 0);
	}

	(*env)->DeleteLocalRef( env, jEnumValueName );
	return jEnumObject;
}

jobject create_reception_mode_enum_object ( JNIEnv *env, unsigned int enumValue ) {

	jobject jEnumObject 	= NULL;
	jclass  jEnumClass 		= (*env)->FindClass( env, "com/coronis/sdk/protocol/api/ConstantParams$ReceptionMode");
	jstring jEnumValueName  = NULL;

	LOG_DEBUG(g_Logger, "create_reception_mode_enum_object: Entered function to set reception mode to %d", enumValue);

	if (enumValue == RECEPTION_MODE_UNICAST)
		jEnumValueName = (*env)->NewStringUTF( env, "Unicast" );
	else if (enumValue == RECEPTION_MODE_MULTICAST)
		jEnumValueName = (*env)->NewStringUTF( env, "Multicast" );
	else if (enumValue == RECEPTION_MODE_BROADCAST)
		jEnumValueName = (*env)->NewStringUTF( env, "Broadcast" );
	 else
		 return NULL;

	LOG_DEBUG(g_Logger, "create_reception_mode_enum_object: Creating enum object", 0);
	// create enumeration with desired value
	jEnumObject = (*env)->CallStaticObjectMethod(env, jEnumClass,
					(*env)->GetStaticMethodID(env, jEnumClass, "valueOf",
							"(Ljava/lang/String;)Lcom/coronis/sdk/protocol/api/ConstantParams$ReceptionMode;"), jEnumValueName);

	if(jEnumObject != NULL) {
		LOG_DEBUG(g_Logger, "create_reception_mode_enum_object: Enum object created", 0);
	}

	if(jEnumObject == NULL) {
		LOG_ERROR(g_Logger, "create_reception_mode_enum_object: Failed to create enum object", 0);
	}

	(*env)->DeleteLocalRef( env, jEnumValueName );

	LOG_ERROR(g_Logger, "create_reception_mode_enum_object: Reception mode enum object has been created!", 0);
	return jEnumObject;
}

/**
 *
 */
jobject create_physical_layer_object ( JNIEnv *env, PhysicalLayer enumValue ) {
	jobject jEnumObject 	= NULL;
	jclass  jEnumClass 		= (*env)->FindClass( env, "com/coronis/sdk/protocol/api/ConstantParams$PhysicalLayer");
	jstring jEnumValueName  = NULL;

	LOG_DEBUG(g_Logger, "create_physical_layer_object: Entered function to set reception mode to %d", enumValue);

	if (enumValue == MONO_CHANNEL_868MHZ_9600BD)
		jEnumValueName = (*env)->NewStringUTF( env, "MonoChannel_868Mhz_9600Bd" );
	else if (enumValue == FHSS_868MHZ_9600BD)
		jEnumValueName = (*env)->NewStringUTF( env, "FHSS_868Mhz_9600Bd" );
	else if (enumValue == MONO_CHANNEL_868MHZ_500mW_19200BD )
		jEnumValueName = (*env)->NewStringUTF( env, "MonoChannel_869Mhz500mW_19200Bd" );
	 else {

		 return NULL;
	 }
	LOG_DEBUG(g_Logger, "create_physical_layer_object: Creating enum object", 0);
	// create enumeration with desired value
	jEnumObject = (*env)->CallStaticObjectMethod(env, jEnumClass,
					(*env)->GetStaticMethodID(env, jEnumClass, "valueOf",
							"(Ljava/lang/String;)Lcom/coronis/sdk/protocol/api/ConstantParams$PhysicalLayer;"), jEnumValueName);

	if(jEnumObject != NULL) {
		LOG_DEBUG(g_Logger, "create_physical_layer_object: Enum object created", 0);
	}

	if(jEnumObject == NULL) {
		LOG_ERROR(g_Logger, "create_physical_layer_object: Failed to create enum object", 0);
	}

	(*env)->DeleteLocalRef( env, jEnumValueName );
	return jEnumObject;
}

_bool get_physical_config_field_from_object( JNIEnv * env, jobject object,
		jclass classID, char *enumItemName, PhysicalLayer *enumItemValue, int *iRet,
		const int iRetCode) {

	_bool bRet = _false;

	LOG_DEBUG(g_Logger, "get_physical_config_field_from_object: Entered function", 0);

	jfieldID fieldID = (*env)->GetFieldID( env, classID, enumItemName, "Lcom/coronis/sdk/protocol/api/ConstantParams$PhysicalLayer;");
	if ( fieldID != NULL ) {

		LOG_DEBUG(g_Logger, "get_physical_config_field_from_object: Got field ID PhysicalLayer from container object", 0);
		jobject fieldValue = (*env)->GetObjectField( env, object, fieldID );

		if ( fieldValue != NULL ) {
			LOG_DEBUG(g_Logger, "get_physical_config_field_from_object: Got PhysicalLayer field value", 0);
			jclass classRadioChannelEnumID = (*env)->GetObjectClass( env, fieldValue);
			if ( classRadioChannelEnumID != NULL ) {
				jmethodID methodID = (*env)->GetMethodID( env, classRadioChannelEnumID, "name", "()Ljava/lang/String;");
				LOG_DEBUG(g_Logger, "get_physical_config_field_from_object: Got transmissionRadioChannel classID", 0);
				if ( methodID != NULL ) {
					LOG_DEBUG(g_Logger, "get_physical_config_field_from_object: Got PhyscalLayer enum NAME field", 0);
					jstring value = (jstring)(*env)->CallObjectMethod( env, fieldValue, methodID );
					const char* valueNative = (*env)->GetStringUTFChars(env, value, 0);

					bRet = _true;
					if (strcmp(valueNative, "MonoChannel_868Mhz_9600Bd") == 0)
				        *enumItemValue =  MONO_CHANNEL_868MHZ_9600BD;
					else if (strcmp(valueNative, "FHSS_868Mhz_9600Bd") == 0)
				        *enumItemValue =  FHSS_868MHZ_9600BD;
					else if (strcmp(valueNative, "MonoChannel_869Mhz500mW_19200Bd") == 0)
				        *enumItemValue =  MONO_CHANNEL_868MHZ_500mW_19200BD;
					else {
						if (iRet)*iRet = iRetCode;
						bRet = _false;
					}

					LOG_DEBUG( g_Logger, "get_physical_config_field_from_object: Java EnumValue is : %s, C EnumValue is %d", valueNative, *enumItemValue);
				}
				(*env)->DeleteLocalRef( env, classRadioChannelEnumID);
			}
			(*env)->DeleteLocalRef( env, fieldValue);
		}
	}

	LOG_DEBUG(g_Logger, "get_physical_config_field_from_object: Exit function", 0);
	return bRet;
}
#endif //_JAVA_WRAPPER
