/*******************************************************************************
 * Copyright (c) 2012 Coronis
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Contributors:
 *     Coronis - initial API and implementation
 *******************************************************************************/

#ifndef SERIAL_H_
#define SERIAL_H_

// domain services
#include <generic_constants.h>

// com_coronis_sdk_serialdriver_api headers
#include <i_serial_driver_service.h>
//#include <serial_frame.h>
#include <serial_driver_status.h>
#include <serial_driver_event.h>

// internal headers
#include "w_serial.h"
#include "u_serial.h"

enum tagSerialPortMonitorStatus {
	SENDING_STATUS_UNKNOWN  = -1,
	STATUS_IDLE             =  0,
	STATUS_BUSY             =  1,
	STATUS_SEND_COMMAND     =  2,
	STATUS_SEND_ACKNOWLEDGE =  3,
	STATUS_WAIT_RESPONSE    =  4,
	STATUS_WAIT_ACKNOWLEDGE =  5
};

#define DEFAULT_LOW_LEVEL_ACKNOWLEDGEMENT_RETRY_COUNT 2
#define DEFAULT_RADIO_BOARD_ACK_TIMEOUT               100
#define DEFAULT_LISTENING_PERIOD_TIMEOUT              20

#endif /* SERIAL_H_ */
