/*******************************************************************************
 * Copyright (c) 2012 Coronis
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Contributors:
 *     Coronis - initial API and implementation
 *******************************************************************************/

#ifndef SERIAL_UTILS_H_
#define SERIAL_UTILS_H_

#include "utils.h"

#include <generic_types.h>
#include <generic_constants.h>
#include <serial_port_constants.h>
#include <loader.h>
#include <serial_driver_status.h>
#include <i_serial_frame.h>
#include <cs/serial_driver_types.h>

_bool is_port_already_initialized( const char* id );

int driver_verify_baudrate( int baudRate );
int driver_verify_databit( int dataBit );
int driver_verify_stopbit( int stopBit );
int driver_verify_parity( int parity );
int driver_verify_flowcontrolmode_in( int flowControlModeIn );
int driver_verify_flowcontrolmode_out( int flowControlModeOut );

const char* get_sending_status( SerialDriverStatus ss );

extern void* g_ModuleHandle;

#endif /* SERIAL_UTILS_H_ */
