/*******************************************************************************
 * Copyright (c) 2012 Coronis
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Contributors:
 *     Coronis - initial API and implementation
 *******************************************************************************/

#ifndef W_SERIAL_H_
#define W_SERIAL_H_

#ifdef _WINDOWS

//#include <Windows.h>

#include "serial_utils.h"

int serial_port_open( const char* id, void** port);
int serial_port_close( const void* port );
int serial_port_send( const void* port, const byte* frame, int frameLen );
int serial_port_recv( const void* port, byte* frame, int frameLen, unsigned int* recvLen );
int serial_port_check( const void* port, unsigned long* amountInInQueue, unsigned long* amountInOutQueue);
int serial_port_set_params( const void* port, int baudRate, int dataBit, int stopBit, int parity, int timeout, int flowControl );

#endif /* _WINDOWS */

#endif /* W_SERIAL_H_ */
