/*******************************************************************************
 * Copyright (c) 2012 Coronis
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Contributors:
 *     Coronis - initial API and implementation
 *******************************************************************************/

/**
 * @file protocol_event.h
 * @brief Enumeration of protocol events
 * that could occurs on a i_protocol_service implementation
 *
 * START_LISTENING - event when the Protocol instance wait for frame on connected serial port\n
 * STOP_LISTENING - event when the Protocol instance stop for frame data on connected serial port\n
 * IGNORED_COMMAND_RECEIVED - event when an invalid command (from the protocol point of view) is received\n
 * SERIALDRIVER_DISCONNECTION - event when a disconnection is detected on serial driver
 */
#ifndef PROTOCOL_EVENT_H_
#define PROTOCOL_EVENT_H_

typedef enum tagProtocolEvent {
	PE_START_LISTENING,
	PE_STOP_LISTENING,
	PE_IGNORED_COMMAND_RECEIVED,
	PE_SERIALDRIVER_DISCONNECTION
} ProtocolEvent;

#endif /* PROTOCOL_EVENT_H_ */
