/*******************************************************************************
 * Copyright (c) 2012 Coronis
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Contributors:
 *     Coronis - initial API and implementation
 *******************************************************************************/
#include "logger_utils.h"

#include <stdio.h>
#include <loader_logger.h>

void protocol_dump_frame (SerialFrame *frame) {

	if (!frame ) {
		LOG_DEBUG(g_Logger, "protocol_dump_frame: Null frame", 0);
		return;
	}

	if (frame->len == 0) {
		LOG_DEBUG(g_Logger, "protocol_dump_frame: Empty frame", 0);
		return;
	}

	int i = 0;
	char buff [100*2 + 1];
	for( ; (i < frame->len) && (i < 100);  i++) {
		sprintf(&buff[i *2], "%02X", frame->frame[i] & 0xFF);
	}
	buff[i *2] = 0;
	LOG_DEBUG(g_Logger, "protocol_dump_frame: %s", buff);

}

void protocol_dump_payload (Payload *payload) {
	if (!payload ) {
		LOG_DEBUG(g_Logger, "protocol_dump_payload: Null payload", 0);
		return;
	}

	if (payload->len == 0) {
		LOG_DEBUG(g_Logger, "protocol_dump_payload: Empty payload", 0);
		return;
	}

	int i = 0;
	char buff [300*2 + 3];
	for( ; (i < payload->len) && (i < 300);  i++) {
		sprintf(&buff[i *2], "%02X", payload->frame[i] & 0xFF);
	}
	buff[i *2] = 0;
	LOG_DEBUG(g_Logger, "protocol_dump_payload: [%d] %s", payload->len, buff);
}
