/*******************************************************************************
 * Copyright (c) 2012 Coronis
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Contributors:
 *     Coronis - initial API and implementation
 *******************************************************************************/

/**
 * @file i_serial_frame.h
 * @brief This interface represents serial frame which could be sent or received
 * by a i_serial_driver_service implementation.
 * Header file serial_driver_types.h, that will include
 * concrete definition of serial driver types must be present
 * into the include path.
 */
#ifndef _I_SERIAL_FRAME_H_
#define _I_SERIAL_FRAME_H_

#include <serial_driver_types.h>

/**
 * Generic buffer that contains the serial frame data.
 */
typedef unsigned char pISerialFrame [SERIALFRAME_BUFFER_LEN];

/**
 *  Data structure used to exchange data over serial port. Used mainly in
 *  sending functions and callback events that receives serial data.
 */
typedef struct tagSerialExchangeData {
	pISerialFrame serialFrame;

}SerialExchangeData;

typedef SerialExchangeData *pSerialExchangeData;

#endif//_I_SERIAL_FRAME_H_
