/*******************************************************************************
 * Copyright (c) 2012 Coronis
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Contributors:
 *     Coronis - initial API and implementation
 *******************************************************************************/

/**
 * @file serial_driver_status.h
 * @brief Enumeration of sending status
 * that could be return by the ISerialDriverService implementation
 */
#ifndef _SERIAL_DRIVER_STATUS_H_
#define _SERIAL_DRIVER_STATUS_H_

typedef enum tagSerialDriverStatus {
	OK_SERIALDRIVER_SUCCESS,
	KO_SENDING_FAILURE,
    KO_SERIALFRAME_REQUIRED,
    KO_SERIALDRIVER_NOT_OPEN,
    KO_SERIALDRIVER_ALREADY_IN_USE,
    KO_SERIALDRIVER_ALREADY_OPEN, // 5
    KO_SERIALDRIVER_LISTENER_ALREADY_REGISTERED,
    KO_SERIALDRIVER_LISTENER_NOT_REGISTERED,
    KO_SERIALDRIVER_MAX_SPY_LISTENER_EXCEED,
    KO_SERIALPORT_DISCONNECTED,
    KO_SERIALPORT_UNEXPECTED_ERROR, // 10
    KO_SERIALPORT_NOT_AVAILABLE,
    KO_PARAM_SERIALPORTID_NOT_EXIST,
    KO_PARAM_BAUDRATE_NOT_VALID,
    KO_PARAM_DATABIT_NOT_VALID,
    KO_PARAM_STOPBIT_NOT_VALID, // 15
    KO_PARAM_PARITY_NOT_VALID,
    KO_PARAM_FLOWCONTROLIN_NOT_VALID,
    KO_PARAM_FLOWCONTROLOUT_NOT_VALID,
    KO_PARAM_LISTENINGPERIOD_NOT_VALID,
    KO_PARAM_NOT_VALID // 20
} SerialDriverStatus;

#endif//_SERIAL_DRIVER_STATUS_H_
