/*******************************************************************************
 * Copyright (c) 2012 Coronis
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Contributors:
 *     Coronis - initial API and implementation
 *******************************************************************************/
#ifndef I_LOGGER_H_
#define I_LOGGER_H_

//#define FN_INIT_LOG  "init_log"
#define FN_INIT_LOG_FROM_PROPR_FILE  "init_log_from_property_file"
#define FN_DEBUG     "debug"
#define FN_INFO      "info"
#define FN_WARN      "warn"
#define FN_ERROR     "error"
#define FN_FATAL     "fatal"


#ifdef __cplusplus
extern "C" {  
#endif

typedef void (* init_log_t)( );
typedef void (* init_log_from_property_file_t)(const char* fileName );
typedef void (* debug_t)( const char* format, ... );
typedef void (* info_t)( const char* format, ... );
typedef void (* warn_t)( const char* format, ... );
typedef void (* error_t_)( const char* format, ... );
typedef void (* fatal_t)( const char* format, ... );

#ifdef __cplusplus
}
#endif

#endif /* I_LOGGER_H_ */
