/*******************************************************************************
 * Copyright (c) 2012 Coronis
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Contributors:
 *     Coronis - initial API and implementation
 *******************************************************************************/
#ifndef SERIALCOMMPORTIDENTIFIER_H_
#define SERIALCOMMPORTIDENTIFIER_H_

#ifdef _WINDOWS
#include <Windows.h>
#include <setupapi.h>
#include <stdio.h>
#include <tchar.h>
#else
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <dirent.h>
#include <termios.h>
#include <sys/ioctl.h>
#include <linux/serial.h>
#include <unistd.h>
#endif//_WINDOWS

#ifdef __cplusplus
extern "C" {
#endif

/**
 * 	Perform a system API call and get's an array of available ports ID
 * @param ids
 * @param idsLen
 */
void driver_get_serial_port_ids( char* ids, int idsLen );

#ifdef __cplusplus
}
#endif

#endif /* SERIALCOMMPORTIDENTIFIER_H_ */
