/*******************************************************************************
 * Copyright (c) 2012 Coronis
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Contributors:
 *     Coronis - initial API and implementation
 *******************************************************************************/
#ifdef _JAVA_WRAPPER
#include <generic_constants.h>
#include <serial_comm_port_identifier.h>

#include "com_coronis_sdk_domain_internal_SerialCommPortIdentifier.h"

JNIEXPORT jstring JNICALL JNIFUNCTION(getNativeSerialPortIds) (JNIEnv *env, jobject this) {
	jstring ret = 0;
	char ids[DRIVER_ID_LEN*256] = "";
	driver_get_serial_port_ids( ids, sizeof(ids)/sizeof(ids[0]) );
	int size = 0;
	jchar jids[DRIVER_ID_LEN*256] = {0};
	while ( ( ids[size] + ids[size+1] ) != 0 ) {
		jids[size] = ids[size];
		++size;
	}
	++size;

	jclass strClass = (*env)->FindClass( env, "java/lang/String");
	if ( strClass != 0 ) {
		// Get the method ID for the String(char[],int,int) constructor
		jmethodID cid = (*env)->GetMethodID( env, strClass, "<init>", "([CII)V");
		if ( cid != 0 ) {
			// Create a char[] that holds the string characters
			jcharArray elemArr = (*env)->NewCharArray(env, size);
			if (elemArr != 0) {
				(*env)->SetCharArrayRegion(env, elemArr, 0, size, jids);
				// Construct a java.lang.String object
				ret = (*env)->NewObject(env, strClass, cid, elemArr, 0, size);
				// Free local references
				(*env)->DeleteLocalRef(env, elemArr);
			}
		}
	    (*env)->DeleteLocalRef(env, strClass);
	}
	return ret;
}
#endif //_JAVA_WRAPPER
