/*******************************************************************************
 * Copyright (c) 2012 Coronis
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Contributors:
 *     Coronis - initial API and implementation
 *******************************************************************************/
#ifdef _JAVA_WRAPPER
#include <JNI/domain_jni.h>

JavaVM *g_jvm = NULL;

/* Defined by native libraries. */

/*
 * You can invoke any JNI functions in an implementation of JNI_Onload.
 * A typical use of the JNI_OnLoad handler is caching the JavaVM pointer, class references, or method and field IDs
 * */
#ifdef  _WINDOWS
JNIEXPORT jint JNICALL _JNI_OnLoad(JavaVM *jvm, void *reserved) {
#else
JNIEXPORT jint JNICALL JNI_OnLoad(JavaVM *jvm, void *reserved) {
#endif//_WINDOWS

	g_jvm = jvm;
	initialize_global_class_references( jvm, JNI_VERSION_1_2 );
	return JNI_VERSION_1_2;
}

#ifdef  _WINDOWS
JNIEXPORT jint JNICALL _JNI_OnUnload(JavaVM *jvm, void *reserved) {
	uninitialize_global_class_references( jvm, JNI_VERSION_1_2 );
	return JNI_VERSION_1_2;
#else
JNIEXPORT void JNICALL JNI_OnUnload(JavaVM *jvm, void *reserved) {
	uninitialize_global_class_references( jvm, JNI_VERSION_1_2 );
#endif//_WINDOWS

}
#endif //_JAVA_WRAPPER
