/*******************************************************************************
 * Copyright (c) 2012 Coronis
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Contributors:
 *     Coronis - initial API and implementation
 *******************************************************************************/
#ifndef _GENERIC_CONSTANTS_H_
#define _GENERIC_CONSTANTS_H_

#ifndef  NULL
#define  NULL 0
#endif //NULL

#ifndef  MAX_PATH
#define  MAX_PATH 260
#endif //MAX_PATH

/*
 * Max serial port length
 * for Windows is \\.\COMXXX
 * for Linux is /dev/ttySXXX
 * for Linux is /dev/ttyUSBXXX
 */
#define DRIVER_ID_LEN  15

// Maximum number of serial port connection for each serial driver library
// This value could be adapted if the system need a known number of SerialDriver instance
#define MAX_DRIVER_NUM 5

// Maximum number of protocol instances for each protocol library
// This value could be adapted if the system need a known number of Protocol instance
#define MAX_PROTOCOL_NUM 5

#define MAX_SPY_NUM    10

#define MAX_PROPERTY_LENGTH 256

#ifndef ARRAYSIZE
#define ARRAYSIZE( p ) ( sizeof(p) / sizeof(p[0]) )
#endif

#ifndef min
#define min(a,b)            (((a) < (b)) ? (a) : (b))
#endif

#ifndef  OK
#define OK 0
#endif

#endif//_GENERIC_CONSTANTS_H_
