/*******************************************************************************
 * Copyright (c) 2012 Coronis
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Contributors:
 *     Coronis - initial API and implementation
 *******************************************************************************/

/**
 * @file serial_driver_event.h
 * @brief Enumeration of serial driver events
 * that could occurs on a i_serial_driver_service implementation
 *
 * START_LISTENING - event when the SerialDriver instance wait for frame on connected serial port\n
 * STOP_LISTENING - event when the SerialDriver instance stop for frame data on connected serial port\n
 * IGNORED_FRAME_RECEIVED - event when an invalid frame (from the serial driver protocol point of view) is received\n
 * SERIALPORT_DISCONNECTION - event when a disconnection is detected on serial port
 */
#ifndef _SERIAL_DRIVER_EVENT_H_
#define _SERIAL_DRIVER_EVENT_H_

typedef enum tagSerialDriverEvent {
	START_LISTENING,
	STOP_LISTENING,
	IGNORED_FRAME_RECEIVED,
	SERIALPORT_DISCONNECTION
} SerialDriverEvent;

#endif//_SERIAL_DRIVER_EVENT_H_
